Do-compile 18 KB
Newer Older
1
#!/usr/bin/perl -w
unknown's avatar
unknown committed
2 3

use Getopt::Long;
4 5 6 7 8 9

@config_options= ();
@make_options= ();

$opt_distribution=$opt_user=$opt_config_env="";
$opt_dbd_options=$opt_perl_options=$opt_config_options=$opt_make_options=$opt_suffix="";
10
$opt_tmp=$opt_version_suffix="";
11
$opt_help=$opt_delete=$opt_debug=$opt_stage=$opt_no_test=$opt_no_perl=$opt_with_low_memory=$opt_fast_benchmark=$opt_static_client=$opt_static_server=$opt_static_perl=$opt_sur=$opt_with_small_disk=$opt_local_perl=$opt_tcpip=$opt_build_thread=$opt_use_old_distribution=$opt_enable_shared=$opt_no_crash_me=$opt_no_strip=0;
12
$opt_innodb=$opt_bdb=$opt_raid=$opt_libwrap=0;
unknown's avatar
unknown committed
13

14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53
GetOptions(
	"bdb",
	"build-thread=i",
	"config-env=s",
	"config-options=s" => \@config_options,
	"dbd-options=s",
	"debug",
	"delete",
	"distribution=s",
	"enable-shared",
	"fast-benchmark",
	"help|Information",
	"innodb",
	"libwrap",
	"local-perl",
	"make-options=s" => \@make_options,
	"no-crash-me",
	"no-perl",
	"no-strip",
	"no-test|no-mysqltest",
	"perl-files=s",
	"perl-options=s",
	"raid",
	"stage=i",
	"static-client",
	"static-perl",
	"static-server",
	"suffix=s",
	"sur",
	"tcpip",
	"tmp=s",
	"use-old-distribution",
	"user=s",
	"version-suffix=s",
	"with-low-memory",
	"with-other-libc=s",
	"with-small-disk",
) || usage();

usage() if ($opt_help);
unknown's avatar
unknown committed
54 55
usage() if (!$opt_distribution);

56
if ($opt_bdb && $opt_version_suffix eq "")
unknown's avatar
unknown committed
57
{
58
  $opt_version_suffix="-max";
unknown's avatar
unknown committed
59 60
}

61 62 63 64 65 66 67 68 69 70 71 72
if (@make_options > 0)
{
	chomp(@make_options);
	$opt_make_options= join(" ", @make_options);
}

if (@config_options > 0)
{
	chomp(@config_options);
	$opt_config_options= join(" ", @config_options);
}

unknown's avatar
unknown committed
73
chomp($host=`hostname`);
unknown's avatar
unknown committed
74 75
$full_host_name=$host;
$connect_option= ($opt_tcpip ? "--host=$host" : "");
unknown's avatar
unknown committed
76
$host =~ /^([^.-]*)/;
unknown's avatar
unknown committed
77
$host=$1 . $opt_suffix;
unknown's avatar
unknown committed
78 79
$email="$opt_user\@mysql.com";
$pwd = `pwd`; chomp($pwd);
80
$log="$pwd/Logs/$host$opt_version_suffix.log";
unknown's avatar
unknown committed
81
$opt_distribution =~ /(mysql[^\/]*)\.tar/;
unknown's avatar
unknown committed
82 83 84 85 86 87 88
$ver=$1;
$gcc_version=which("gcc");
if (defined($gcc_version) && ! $opt_config_env)
{
  $tmp=`$gcc_version -v 2>&1`;
  if ($tmp =~ /version 2\.7\./)
  {
unknown's avatar
unknown committed
89
    $opt_config_env= 'CC=gcc CFLAGS="-O2 -fno-omit-frame-pointer" CXX=gcc CXXFLAGS="-O2 -fno-omit-frame-pointer"';
unknown's avatar
unknown committed
90
  }
91 92 93 94
  elsif ($tmp =~ /version 3\.0\./)
  {
    $opt_config_env= 'CC=gcc CFLAGS="-O3 -fno-omit-frame-pointer" CXXFLAGS="-O3 -fno-omit-frame-pointer -felide-constructors -fno-exceptions -fno-rtti"';
  }
unknown's avatar
unknown committed
95 96
  else
  {
unknown's avatar
unknown committed
97
    $opt_config_env= 'CC=gcc CFLAGS="-O3 -fno-omit-frame-pointer" CXX=gcc CXXFLAGS="-O3 -fno-omit-frame-pointer -felide-constructors -fno-exceptions -fno-rtti"';
unknown's avatar
unknown committed
98 99
  }
}
unknown's avatar
unknown committed
100 101

$new_opt_tmp=0;
unknown's avatar
unknown committed
102 103
if ($opt_tmp)
{
unknown's avatar
unknown committed
104 105 106 107 108
  if (! -d $opt_tmp)
  {
    safe_system("mkdir $opt_tmp");
    $new_opt_tmp=1;
  }
unknown's avatar
unknown committed
109 110 111 112 113 114
  $ENV{'TMPDIR'}=$opt_tmp;
}
else
{
  $opt_tmp="/tmp";
}
unknown's avatar
unknown committed
115
$bench_tmpdir="$opt_tmp/my_build-$host";
unknown's avatar
unknown committed
116
$ENV{'PATH'}= "$pwd/$host/bin:" . $ENV{'PATH'}; 
unknown's avatar
unknown committed
117
$make=which("gmake","make");	# Can't use -j here!
unknown's avatar
unknown committed
118 119 120 121 122
$tar=which("gtar","tar");
$sendmail=find("/usr/lib/sendmail","/usr/sbin/sendmail");
$sur= $opt_sur ? "/my/local/bin/sur" : "";
delete $ENV{'MYSQL_PWD'};	# Reset possibly password
delete $ENV{'MY_BASEDIR_VERSION'};
unknown's avatar
unknown committed
123
$ENV{'MYSQL_TCP_PORT'}= $mysql_tcp_port= 3334 + $opt_build_thread*2;
unknown's avatar
unknown committed
124
$ENV{'MYSQL_UNIX_PORT'}=$mysql_unix_port="$opt_tmp/mysql$opt_suffix.build";
unknown's avatar
unknown committed
125
$ENV{"PERL5LIB"}="$pwd/$host/perl5:$pwd/$host/perl5/site_perl";
126
$slave_port=$mysql_tcp_port+16;
unknown's avatar
unknown committed
127
$manager_port=$mysql_tcp_port+1;
128

unknown's avatar
unknown committed
129 130 131 132 133 134 135 136 137 138 139 140 141
if ($opt_stage == 0)
{
  system("mkdir Logs") if (! -d "Logs");
  system("mv $log ${log}-old") if (-f $log);
  unlink($log);
}

open(LOG,">>$log") || abort("Can't open log file, error $?");
select LOG;
$|=1;
select STDOUT;
$|=1;

142 143
info("Compiling MySQL$opt_version_suffix at $host$opt_suffix, stage: $opt_stage\n");

144 145 146 147 148 149 150 151
if (-x "$host/bin/mysqladmin")
{
  log_system("$host/bin/mysqladmin --no-defaults -u root -S $mysql_unix_port -s shutdown");
  log_system("$host/bin/mysqladmin --no-defaults -u root -P $mysql_tcp_port -h $host -s shutdown");
  log_system("$host/bin/mysqladmin --no-defaults -u root -P $slave_port -h $host -s shutdown");
  log_system("$host/bin/mysqladmin --no-defaults -u root -P 9306 -h $host -s shutdown");
  log_system("$host/bin/mysqladmin --no-defaults -u root -P 9307 -h $host -s shutdown");
}
unknown's avatar
unknown committed
152
kill_all("mysqlmanager");
unknown's avatar
unknown committed
153 154 155 156

if ($opt_stage == 0)
{
  print "$host: Removing old distribution\n" if ($opt_debug);
unknown's avatar
unknown committed
157 158 159 160
  if (!$opt_use_old_distribution)
  {
    system("mkdir $host") if (! -d $host);
    system("touch $host/mysql-fix-for-glob");
161
    rm_all(<$host/mysql*>);
unknown's avatar
unknown committed
162 163
    system("mkdir $host/bin") if (! -d "$host/bin");
  }
unknown's avatar
unknown committed
164 165 166 167
  rm_all("$host/test");
  system("mkdir $host/test") if (! -d "$host/test");
}

168
safe_cd($host);
unknown's avatar
unknown committed
169
if ($opt_stage == 0 && ! $opt_use_old_distribution)
unknown's avatar
unknown committed
170 171
{
  safe_system("gunzip < $opt_distribution | $tar xf -");
unknown's avatar
unknown committed
172 173

  # Fix file times; This is needed because the time for files may be
174 175 176 177 178
  # in the future.  The following is done this way to ensure that
  # we don't get any errors from xargs touch
  system("touch timestamp");
  sleep(2);
  system("touch timestamp2");
179 180 181
  system("find . -newer timestamp -print | xargs touch");
  unlink("timestamp");
  unlink("timestamp2");
unknown's avatar
unknown committed
182 183
  sleep(2);
  # Ensure that files we don't want to rebuild are newer than other files
184
  safe_cd($ver);
unknown's avatar
unknown committed
185 186 187 188 189 190 191
  foreach $name ("configure",
		 "Docs/include.texi",
		 "Docs/*.html", "Docs/manual.txt", "Docs/mysql.info",
		 "sql/sql_yacc.h", "sql/sql_yacc.cc")
  {
    system("touch $name");
  }
192 193
  # Fix some file modes in BDB tables that makes life harder.
  system("chmod -R u+rw .");
unknown's avatar
unknown committed
194
}
unknown's avatar
unknown committed
195

196
safe_cd("$pwd/$host/$ver");
197 198 199 200

#
# Configure the sources
#
unknown's avatar
unknown committed
201
if ($opt_stage <= 1)
unknown's avatar
unknown committed
202
{
203
  # Fix files if this is in another timezone than the build host
unknown's avatar
unknown committed
204
  unlink("config.cache");
unknown's avatar
unknown committed
205 206
  unlink("bdb/build_unix/config.cache");
  unlink("innobase/config.cache");
unknown's avatar
unknown committed
207
  log_system("$make clean") if ($opt_use_old_distribution);
208 209 210 211 212 213 214 215
  $opt_config_options.= " --disable-shared" if (!$opt_enable_shared); # Default for binary versions
  $opt_config_options.= " --with-berkeley-db" if ($opt_bdb);
  $opt_config_options.= " --with-client-ldflags=-all-static" if ($opt_static_client);
  $opt_config_options.= " --with-libwrap" if ($opt_libwrap);
  $opt_config_options.= " --with-low-memory" if ($opt_with_low_memory);
  $opt_config_options.= " --with-mysqld-ldflags=-all-static" if ($opt_static_server);
  $opt_config_options.= " --with-raid" if ($opt_raid);

216 217
  # Only enable InnoDB when requested (required to be able to
  # build the "Classic" packages that do not include InnoDB)
unknown's avatar
unknown committed
218 219 220 221 222 223 224 225
	if ($opt_innodb)
	{
		$opt_config_options.= " --with-innodb";
	}
	else
	{
		$opt_config_options.= " --without-innodb";
	}
226

227 228
  if ($opt_with_other_libc)
  {
229 230
    $opt_with_other_libc= " --with-other-libc=$opt_with_other_libc";
    $opt_config_options.= $opt_with_other_libc;
231
  }
232

233
  check_system("$opt_config_env ./configure --prefix=/usr/local/mysql --with-comment=\"Official MySQL$opt_version_suffix binary\" --with-extra-charsets=complex --with-server-suffix=\"$opt_version_suffix\" --enable-thread-safe-client --enable-local-infile $opt_config_options","Thank you for choosing MySQL");
unknown's avatar
unknown committed
234 235 236 237 238 239
  if (-d "$pwd/$host/include-mysql")
  {
    safe_system("cp -r $pwd/$host/include-mysql/* $pwd/$host/$ver/include");
  }
}

240 241 242
#
# Compile the binaries
#
unknown's avatar
unknown committed
243 244
if ($opt_stage <= 2)
{
245
  my ($command);
unknown's avatar
unknown committed
246
  unlink($opt_distribution) if ($opt_delete && !$opt_use_old_distribution);
247 248 249
  $command=$make;
  $command.= " $opt_make_options" if (defined($opt_make_options) && $opt_make_options ne "");
  safe_system($command);
unknown's avatar
unknown committed
250 251 252
}

#
253
# Create the binary distribution
unknown's avatar
unknown committed
254 255 256
#
if ($opt_stage <= 3)
{
257
  my $flags= "";
unknown's avatar
unknown committed
258 259
  log_system("rm -fr mysql-3* mysql-4* $pwd/$host/*.tar.gz");
  log_system("nm -n sql/mysqld | gzip -9 -v 2>&1 > sql/mysqld.sym.gz | cat");
260

261
  $flags.= "--no-strip" if ($opt_no_strip);
262
  check_system("scripts/make_binary_distribution --tmp=$opt_tmp --suffix=$opt_suffix $flags",".tar.gz created");
unknown's avatar
unknown committed
263
  safe_system("mv mysql*.tar.gz $pwd/$host");
unknown's avatar
unknown committed
264 265 266 267 268 269 270 271
  if (-f "client/.libs/mysqladmin")
  {
    safe_system("cp client/.libs/mysqladmin $pwd/$host/bin");
  }
  else
  {
    safe_system("cp client/mysqladmin $pwd/$host/bin");
  }  
unknown's avatar
unknown committed
272
  safe_system("$make clean") if ($opt_with_small_disk);
unknown's avatar
unknown committed
273 274
}

unknown's avatar
unknown committed
275 276 277 278 279
$tar_file=<$pwd/$host/*.tar.gz>;
if (!defined($tar_file))
{
  $tar_file=<$pwd/$host/*.tgz>;
}
280 281 282 283

#
# Unpack the binary distribution
#
unknown's avatar
unknown committed
284 285 286 287 288 289 290
if ($opt_stage <= 4 && !$opt_no_test)
{
  rm_all(<$pwd/$host/test/*>);
  safe_cd("$pwd/$host/test");
  safe_system("gunzip < $tar_file | $tar xf -");
}

unknown's avatar
unknown committed
291
$tar_file =~ /(mysql[^\/]*)\.tar/;
unknown's avatar
unknown committed
292 293
$ver=$1;
$test_dir="$pwd/$host/test/$ver";
unknown's avatar
unknown committed
294
$ENV{"LD_LIBRARY_PATH"}= "$test_dir/lib:" . $ENV{"LD_LIBRARY_PATH"};
unknown's avatar
unknown committed
295

296 297 298 299
#
# Run the test suite
#
if ($opt_stage <= 5 && !$opt_no_test)
unknown's avatar
unknown committed
300
{
301
  system("mkdir $bench_tmpdir") if (! -d $bench_tmpdir);
unknown's avatar
unknown committed
302
  safe_cd("${test_dir}/mysql-test");
303
  check_system("./mysql-test-run --warnings --tmpdir=$bench_tmpdir --master_port=$mysql_tcp_port --slave_port=$slave_port --manager-port=$manager_port --no-manager --sleep=10", "tests were successful");
unknown's avatar
unknown committed
304 305
}

306
#
307
# Start the server if we are going to run any of the benchmarks
308
#
309
if (!$opt_no_test)
unknown's avatar
unknown committed
310
{
unknown's avatar
unknown committed
311
  my $extra;
unknown's avatar
unknown committed
312 313 314 315
  safe_cd($test_dir);
  log_system("./bin/mysqladmin --no-defaults -u root -S $mysql_unix_port -s shutdown") || info("There was no mysqld running\n");
  sleep(2);
  log_system("rm -f  ./data/mysql/*");
316
  check_system("scripts/mysql_install_db --no-defaults --skip-locking","https://order");
unknown's avatar
unknown committed
317 318 319
  $extra="";
  if ($opt_bdb)
  {
320
    $extra.=" --bdb_cache_size=16M --bdb_max_lock=60000"
unknown's avatar
unknown committed
321 322 323
  }
  if ($opt_innodb)
  {
unknown's avatar
unknown committed
324
    $extra.=" --innodb_data_file_path=ibdata1:100M:autoextend";
unknown's avatar
unknown committed
325
  }
unknown's avatar
unknown committed
326
  safe_system("./bin/mysqld --no-defaults --basedir . --datadir ./data --skip-locking $extra >> $log 2>&1 &");
unknown's avatar
unknown committed
327 328 329
  sleep(2);
}

330 331 332
#
# Compile and install the required Perl modules
#
unknown's avatar
unknown committed
333
if ($opt_stage <= 7 && $opt_perl_files && !$opt_no_perl && !$opt_no_test)
unknown's avatar
unknown committed
334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364
{
  safe_cd($test_dir);
  rm_all("perl");
  safe_system("mkdir perl");
  $ENV{'IN_MYSQL_DISTRIBUTION'}=1;
  $ENV{'MYSQL_BUILD'}=$test_dir;

  foreach $module (split(/,/,$opt_perl_files))
  {
    my $options;
    safe_cd("$test_dir/perl");
    if ($opt_debug)
    {
      safe_system("gunzip < $pwd/$module | tar xvf -");
    }
    else
    {
      safe_system("gunzip < $pwd/$module | tar xf -");
    }
    $module =~ m|([^/]+)\.tar\.gz|;
    $module = $1;
    safe_cd($module);
    $options="";
    $options= "--mysql-install --noprompt --mysql-incdir=$test_dir/include --mysql-libdir=$test_dir/lib -nomsql-install -nomsql1-install --mysql-test-db=test $opt_dbd_options" if ($module =~ /Msql-Mysql/);
    $options.= " PREFIX=$pwd/$host INSTALLPRIVLIB=$pwd/$host/perl5 INSTALLSCRIPT=$pwd/$host/bin INSTALLSITELIB=$pwd/$host/perl5/site_perl INSTALLBIN=$pwd/$host/bin INSTALLMAN1DIR=$pwd/$host/man INSTALLMAN3DIR=$pwd/$host/man/man3" if ($opt_local_perl);
    $options.= " $opt_perl_options" if (defined($opt_perl_options));
    safe_system($opt_static_perl ? "perl Makefile.PL -static $options" : "perl Makefile.PL $options");
    safe_system("$make ; $sur $make install");
  }
}

365 366 367
#
# Run crash-me test
#
368
if ($opt_stage <= 8 && !$opt_no_test && !$opt_no_crash_me)
unknown's avatar
unknown committed
369 370 371
{
  safe_cd("$test_dir/sql-bench");
  log_system("rm -f limits/mysql.cfg");
372
  safe_system("perl ./crash-me --force --batch-mode $connect_option");
unknown's avatar
unknown committed
373 374
}

375 376 377
#
# Run sql-bench Benchmarks
#
unknown's avatar
unknown committed
378
if ($opt_stage <= 9 && !$opt_no_test)
unknown's avatar
unknown committed
379 380 381 382
{
  safe_cd("$test_dir/sql-bench");
  log_system("rm -f output/*");
  $tmp= $opt_fast_benchmark ? "--fast --user root --small-test" : "";
383
  check_system("perl ./run-all-tests --log --die-on-errors $connect_option $tmp","RUN-mysql");
unknown's avatar
unknown committed
384 385 386 387
  if ($opt_innodb)
  {
    check_system("perl ./run-all-tests --log --suffix=\"_innodb\" --die-on-errors $connect_option $tmp --create-option=\"type=innodb\"","RUN-mysql");
  }
388 389 390 391
  if ($opt_bdb)
  {
    check_system("perl ./run-all-tests --log --suffix=\"_bdb\" --die-on-errors $connect_option $tmp --create-option=\"type=bdb\"","RUN-mysql");
  }
unknown's avatar
unknown committed
392 393
}

unknown's avatar
unknown committed
394 395 396 397
rm_all($bench_tmpdir);
rm_all("$opt_tmp") if ($new_opt_tmp);

log_system("$pwd/$host/bin/mysqladmin --no-defaults -S $mysql_unix_port -u root shutdown");
unknown's avatar
unknown committed
398 399 400 401 402 403 404 405 406 407
print LOG "ok\n";
close LOG;
print "$host: ok\n";

exit 0;


sub usage
{
print <<EOF;
408
$0  version 1.4
unknown's avatar
unknown committed
409 410 411

$0 takes the following options:

412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438
--bdb
Compile with support for Berkeley DB tables

--config-env <environment for configure>
To set up the environment, like 'CC=cc CXX=gcc CXXFLAGS=-O3'

--config-options <options>
To add some extra options to configure (e.g. '--with-perl=yes')

--dbd-options <options>
Options for Makefile.PL when configuring msql-mysql-modules.

--debug
Print all shell commands on stdout.

--delete
Delete the distribution file.

--distribution <distribution_file>
Name of the MySQL source distribution file.

--enable-shared
Compile with shared libraries

--fast-benchmark
Run fast benchmark only to speed up testing

unknown's avatar
unknown committed
439 440 441
--help or --Information
Show this help

unknown's avatar
unknown committed
442 443 444
--innodb
Compile with support for Innodb tables

445 446
--libwrap
Compile with TCP wrapper support
unknown's avatar
unknown committed
447

448 449
--local-perl
Install Perl modules locally
unknown's avatar
unknown committed
450

451 452
--make-options <options>
Options to make after configure. (Like 'CXXLD=gcc')
unknown's avatar
unknown committed
453

454 455
--no-crash-me
Do not run the "crash-me" test
unknown's avatar
unknown committed
456

457 458 459 460 461
--no-strip
Do not strip the binaries included in the binary distribution

--no-test
Do not run any tests
unknown's avatar
unknown committed
462 463 464 465

--perl-files=list of files
Compile and install the given perl modules.

466 467
--perl-options <options>
Build Perl modules with the additional options
unknown's avatar
unknown committed
468

469 470
--raid
Compile with RAID support
unknown's avatar
unknown committed
471

472 473
--stage (1-6)
Start script from some specific point.
unknown's avatar
unknown committed
474

475 476
--static-client
Build statically linked client binaries
unknown's avatar
unknown committed
477

478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496
--static-perl
Build statically linked Perl modules

--static-server
Build statically linked server binary

--tcpip
Connect to the server to be tested via TCP/IP instead of socket

--tmp <directory>
Use a different temporary directory than /tmp

--use-old-distribution
Do not clean up the build environment and extract a fresh source
distribution, use an existing one instead.

--user <user_name>
Mail 'user_name'\@mysql.com if something went wrong.
If user is empty then no mail is sent.
497

498
--version-suffix suffix
499
Set name suffix (e.g. 'com' or '-max') for a distribution
500

unknown's avatar
unknown committed
501 502 503
--with-low-memory
Use less memory when compiling.

504 505 506
--with-other-libc <path to libc>
Link against libc and other standard libraries installed in the specified
non-standard location overriding default.
unknown's avatar
unknown committed
507

508 509 510
--with-small-disk
Clean up the build environment before testing the binary distribution
(to save disk space)
unknown's avatar
unknown committed
511 512 513 514 515 516 517
EOF
exit 1;
} 

sub abort
{
  my($message)=@_;
518
  my($mail_header_file);
unknown's avatar
unknown committed
519 520 521 522 523 524 525 526
  print LOG "\n$message\n";
  print "$host: $message\n" if ($opt_debug);
  close LOG;

  if ($opt_user)
  {
    $mail_header_file="$opt_tmp/do-command.$$";
    open(TMP,">$mail_header_file");
unknown's avatar
unknown committed
527
    print TMP "From: mysql\@$full_host_name\n";
unknown's avatar
unknown committed
528
    print TMP "To: $email\n";
529
    print TMP "Subject: $ver$opt_version_suffix compilation failed\n\n";
unknown's avatar
unknown committed
530
    close TMP;
531
    system("tail -40 $log > $log.mail");
532
    system("cat $mail_header_file $log.mail | $sendmail -t -f $email");
unknown's avatar
unknown committed
533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673
    unlink($mail_header_file);
    unlink("$log.mail");
  }
  print LOG "Aborting\n";
  exit 1;
}

sub info
{
  my($message)=@_;
  print LOG "$message\n";
  print "$host: $message\n";
}

sub log_system
{
  my($com)=@_;
  print "$host: $com\n" if ($opt_debug);
  if (defined($log))
  {
    print LOG "$com\n";
    system("$com >> $log 2>&1") &&
      print LOG ("Info: couldn't execute command, error: " . ($? / 256) ."\n");
  }
  else
  {
    system($com) && print "$host: Couldn't execute command, error: " . ($? / 256) ."\n";
  }
}


sub safe_system
{
  my($com,$res)=@_;
  print LOG "$com\n";
  print "$host: $com\n" if ($opt_debug);
  system("$com >> $log 2>&1") && abort("error: Couldn't execute command, error: " . ($? / 256));
}

sub check_system
{
  my($com,$res)=@_;
  my ($error,$found);
  print LOG "$com\n";
  print "$host: $com\n" if ($opt_debug);
  open (COM, "$com 2>&1 < /dev/null|") || abort("Got error " . ($?/256) ." opening pipe");
  $found=0;
  while (<COM>)
  {
    print LOG $_;
    if (index($_,$res) >= 0)
    {
      $found=1;
      last;
    }
  }
  close COM;
  abort("Couldn't find '$res' in the command result") if (!$found);
  print "$host: Command ok\n" if ($opt_debug);
}

sub safe_cd
{
  my($dir)=@_;
  print LOG "cd $dir\n";
  print "$host: cd $dir\n" if ($opt_debug);
  chdir($dir) || abort("Can't cd to $dir");
}

sub which
{
  my(@progs)=@_;
  foreach $prog (@progs)
  {
    chomp($found=`which $prog | head -1`);
    if ($? == 0 && $found ne "" && index($found," ") == -1)
    {
      $found =~ s|/+|/|g;	# Make nicer output
      return $found;
    }
  }
  return undef();
}

sub find
{
  my (@progs)=@_;
  foreach $prog (@progs)
  {
    return $prog if (-x $prog);
  }
  return undef();  
}

#
# Remove recursively all from a directory
# This is needed because problems with NFS and open files
#

sub rm_all
{
  my(@rm_files)=@_;
  my($dir,$current_dir,@files,@dirs);
  $current_dir = `pwd`; chomp($current_dir);

  foreach $dir (@rm_files)
  {
    if (-d $dir)
    {
      chdir($dir) || abort("Can't cd to $dir");
      print "$host: Removing from $dir\n" if ($opt_debug);
      while (<* .*>)
      {
	next if ($_ eq "." x (length($_)));
	if (-d $_)
	{
#	  die "Can't remove directory that starts with ." if ($_ =~ /^\./ && $_ ne ".libs"); # Safety
	  push (@dirs,$_);
	}
	else
	{
	  push (@files,$_);
	}
      }
      if ($#files >= 0)
      {
	system("rm -f " . join(" ",@files)) && abort("Can't remove files from $dir");
      }
      foreach $dir (@dirs)
      {
	rm_all($dir);
      }
      chdir($current_dir) || abort("Can't cd to $current_dir");
      log_system("rmdir $dir");
    }
    else
    {
      system("rm -f $dir") && abort("Can't remove file $dir");
    }
  }
}
unknown's avatar
unknown committed
674 675 676 677

sub kill_all
{
  my ($pattern) = @_;
unknown's avatar
unknown committed
678
  my ($USER,$BSD,$LINUX, $pscmd, $user, $pid);
unknown's avatar
unknown committed
679
  $user=$ENV{'USER'};
unknown's avatar
unknown committed
680
  $BSD = -f '/vmunix' || $ENV{"OS"} eq "SunOS4" || $^O eq 'darwin';
unknown's avatar
unknown committed
681 682 683
  $LINUX = $^O eq 'linux';
  $pscmd = $BSD ? "/bin/ps -auxww" : $LINUX ? "/bin/ps axuw" : "/bin/ps -ef";

unknown's avatar
unknown committed
684 685 686 687 688
  if (!open(PS, "$pscmd|"))
  {
    print "Warning: Can't run $pscmd: $!\n";
    exit;
  }
unknown's avatar
unknown committed
689 690 691 692 693 694 695 696

  # Catch any errors with eval.  A bad pattern, for instance.
 process:
  while ($cand = <PS>)
  {
    chop($cand);
    ($pid_user, $pid) = split(' ', $cand);
    next if $pid == $$;
697 698
    next process if (! ($cand =~ $pattern) || $pid_user ne $user);
    print LOG "Killing $_\n";
unknown's avatar
unknown committed
699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718
    &killpid($pid);
  }
}

sub killpid
{
  local($pid) = @_;
  kill 15, $pid;
  for (1..5)
  {
    sleep 2;
    return if kill(0, $pid) == 0;
  }
  kill 9, $pid;
  for (1..5) {
    sleep 2;
    return if kill(0, $pid) == 0;
  }
  print LOG "$pid will not die!\n";
}